<script setup lang="ts">
import { useFoodStore } from '@/stores/food';
import { useMessageStore } from '@/stores/message';
import { useQueueStore } from '@/stores/queue';
import type Orderitem from '@/types/Orderitem';
import type Queue from '@/types/Queue';
import { onMounted } from 'vue';

const foodStore = useFoodStore();
const queueStore = useQueueStore();
const messageStore = useMessageStore();

const userString = localStorage.getItem("user");
const user = userString ? JSON.parse(userString) : null;

onMounted(async () => {
  queueStore.queues = await queueStore.getOrderToQueue("กำลังรอพ่อครัว");
});

async function Confirm(item: Queue) {
  if (item.orderitem.menu.status != "off") {
    foodStore.queueAdd.id = item.id
    foodStore.queueAdd.orderitem = item.orderitem.id!;
    // foodStore.confirmorder.status = "กำลังปรุงอาหาร"
    foodStore.queueAdd.status = "กำลังปรุงอาหาร"
    foodStore.queueAdd.emp_cook = user.id;
    await foodStore.saveQueue();
    foodStore.clear();
    getQueue()
  }else{
    messageStore.showError("ไม่สามารถ Confirm ได้");
  }

}

function Cancel(item: Queue) {
  queueStore.dialogCancel(item);
  foodStore.queueAdd.id = item.id
  foodStore.queueAdd.orderitem = item.orderitem.id!;
  foodStore.queueAdd.status = "ยกเลิก"
  foodStore.queueAdd.emp_cook = user.id;
  foodStore.confirmorder.id = item.orderitem.id
  foodStore.confirmorder.amount = item.orderitem.amount
  foodStore.confirmorder.order = '' + item.orderitem.order.id!
  foodStore.confirmorder.menu = item.orderitem.menu.id!
  foodStore.confirmorder.note = item.orderitem.note
  foodStore.confirmorder.numCancel = item.orderitem.numCancel + 1;
  foodStore.confirmorder.numConfirm = item.orderitem.numConfirm;
}
async function getQueue() {
  queueStore.queues = await queueStore.getOrderToQueue("กำลังรอพ่อครัว");
}

setInterval(getQueue, 1000);
</script>
<template>
  <v-container fluid fill-height class="d-flex justify-center align-center">
    <v-row class="justify-center">
      <v-col>
        <v-card class="ma-5" color="#EEF2E6">
          <v-row class="justify-center">
            <v-card class="pa-5 ma-2 text-h4 text-center" width="100%" color="#1C6758"
              style="color: white"><label>คิว</label></v-card>
          </v-row>
          <v-table id="queue" style="padding-top: 10px;">
            <thead>
              <tr>
                <th>โต๊ะ</th>
                <th>รายการอาหาร</th>
                <th>หมายเหตุ</th>
                <th width="15%"></th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="item in queueStore.queues" :key="item.id">
                <td>{{ item.orderitem.order.table_id.type + item.orderitem.order.table_id.Number }}</td>
                <td>{{ item.orderitem.menu.name }}</td>
                <td>{{ item.orderitem.note }}</td>
                <td class="text-center">
                  <span style="padding-right: 10px">
                    <v-btn size="x-large" class="btng" @click="Confirm(item)">Confirm</v-btn>
                  </span>
                  <span style="padding-left: 10px"><v-btn size="x-large" class="btnr" @click="Cancel(item)">Cancel</v-btn>
                  </span>
                </td>
              </tr>
            </tbody>
          </v-table>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>
<style scoped>
@import url("https://fonts.googleapis.com/css2?family=Noto+Sans+Thai:wght@100&display=swap");

label {
  font-family: "Noto Sans Thai", sans-serif;
  font-weight: bold;
  font-size: 48px !important;
}

th {
  font-family: "Noto Sans Thai", sans-serif;
  font-size: 24px !important;
  font-weight: bold !important;
}

td {
  font-family: "Noto Sans Thai", sans-serif;
  font-size: 22px !important;
  font-weight: bold;
}

#queue {
  border-collapse: collapse;
  width: 100%;
}

#queue td,
#queue th {
  padding: 10px;
  padding-left: 20px;
}

#queue th {
  padding-top: 12px;
  padding-bottom: 12px;
  text-align: left;
  background-color: #1c6758;
  color: white;
}

#queue tr {
  padding-top: 12px;
  padding-bottom: 12px;
  text-align: left;
  background-color: #ffefcf;
  color: black;
}

.btng {
  font-weight: bold;
  color: white;
  background-color: #00af91;
  width: 110px;
  font-size: 18px;
}

.btnr {
  font-weight: bold;
  color: white;
  background-color: #990000;
  width: 110px;
  font-size: 18px;
}
</style>
